/*****************************************************************************/
/*
 * Linux driver for Easylon USB Interfaces
 *
 * Copyright (c)2003 Gesytec GmbH, Volker Schober (info@gesytec.de)
 * Licensend for use with Easylon USB Interfaces by Gesytec
 *
 * Please compile lonusb.c
 *
 */
 /*****************************************************************************/

#ifndef _DYNBUF_
#define _DYNBUF_

//typedef struct list_head QUEUE, *PQUEUE;
typedef struct _QUEUE {
	spinlock_t polllock;	// lock for managing polling IRP
	struct list_head read_list;
	int QueueCount;
	int MaxQueueCount;
} QUEUE, *PQUEUE;

VOID qinit(PQUEUE queue, int MaxQueueCount);
VOID qexit(PQUEUE queue);
NTSTATUS qflush(PQUEUE queue);

NTSTATUS qwrite(PQUEUE queue, PUCHAR Data, ULONG Anz, BOOLEAN from_user);
LONG qread(PQUEUE queue, PUCHAR Data, ULONG MaxAnz, BOOLEAN to_user);

BOOLEAN qempty(PQUEUE queue);
BOOLEAN qhasdata(PQUEUE queue);
int qcount(PQUEUE queue);

#endif // _DYNBUF_
